<?php

define ('DBFM_DIRECTORY', 1);
define ('DBFM_VERSION', 2);
define ('DBFM_OTHER', 3);         //files

/**
 * builds the properties form - quite a complex form containing multiple tabs however most of the form is built in dbfm_form_properties
 * @param fid - the file id that we need the properties for
 */ 
function dbfm_propertit($fid) {
  global $base_url;
  $err = '';
  $ieflag = FALSE;

  //the file record in a global
  global $gfrec;
  
  //we need to check the user's permission - if the user only has read access here then we'll need to add an extra button to the form
  if (($gfrec = dbfm_selected_file_record($fid,'', $err)) == FALSE) {
    //can't open the file record so error
    $extra = '<p>Unable to open file record - ' . $err . '</p>';
    $output = dbfm_popconstructor2('dbFM Properties Window', '', $extra);
    echo $output;
    exit();
  }
  $writeable = dbfm_check_perm($gfrec, READ_WRITE);

  $retval = dbfm_greybox_js($base_url);     //this should poke the path for greybox into the javascript header
  
  $modulepath = drupal_get_path('module', 'dbfm');
  $tabpath = drupal_get_path('module', 'tabs');
  
  $tab_js = $base_url . '/' . $tabpath .'/tabs.js';
  $tab_core = $base_url . '/' . $tabpath .'/ui.core.js';
  $tab_ui = $base_url . '/' . $tabpath .'/ui.tabs.js';

//  $tabstyle1 = $base_url . '/' . $modulepath .'/css/dbfm_tabs.css';
//forcing css to be reloaded
  $tabstyle1 = $base_url . '/' . $modulepath .'/css/dbfm_tabs.css?parameter=1';
  $tabstyle3 = $base_url . '/' . $tabpath .'/drupal-tabs.css?parameter=1';
  
//  $tabstyle4 = $base_url . '/sites/all/modules/ctools/css/ctools.css';
//  $tabstyle5 = $base_url . '/sites/all/modules/panels/css/panels.css';
   
  $jsjq = $base_url . '/' . 'misc/jquery.js';
  $jsdrup = $base_url . '/' . 'misc/drupal.js';

  $propertiesform = drupal_get_form('dbfm_form_properties');

  //problems - for some reason the properties page doesn't always load the first time dbfm is run in a browser
  //I tried re-ordering the scripts but to no avail. It seems that the style isn't set to display: block the first time through
  //dunno why
  $output  = '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Frameset//EN">'."\n";
  $output .= "<html>\n";
  $output .= "<head>\n";
  $output .= "<title>dbFM File Properties</title>\n";
  $output .= "<script type=\"text/javascript\" src=\"$jsjq\"></script>\n";    //jquery
  $output .= "<script type=\"text/javascript\" src=\"$jsdrup\"></script>\n";  //drupal
  
  $output .= "<script type=\"text/javascript\" src=\"$tab_core\"></script>\n";
  $output .= "<script type=\"text/javascript\" src=\"$tab_ui\"></script>\n";
  $output .= "<script type=\"text/javascript\" src=\"$tab_js\"></script>\n";
  $output .= "<link href=\"$tabstyle1\" rel=\"stylesheet\" type=\"text/css\">";
  $output .= "<link href=\"$tabstyle3\" rel=\"stylesheet\" type=\"text/css\">";
//  $output .= "<link href=\"$stylepath\" rel=\"stylesheet\" type=\"text/css\">";
  
  
  //seems I have to do all the tab settings manually. I'm sure there's an easier way??
  $tabs_speed = variable_get('tabs_speed', 'slow');
  if (is_numeric($tabs_speed)) {
    $tabs_speed = (int) $tabs_speed;
  }
  $output .= "<script type=\"text/javascript\"><!--//--><![CDATA[//><!--\n";
  $output .= "jQuery.extend(Drupal.settings, { \"basePath\": \"/drupal6.12/\", \"tabs\": { \"slide\": " . variable_get('tabs_slide', 0) .", \"fade\":" . variable_get('tabs_fade', 0) . ", \"speed\": \"" . $tabs_speed . "\", \"auto_height\": " . variable_get('tabs_auto_height', 0) . ", \"next_text\": \"" . variable_get('tabs_nav_next', t('next')) . "\", \"previous_text\": \"" . variable_get('tabs_nav_prev', t('previous')) . "\" } });\n";
  $output .= "//--><!]]></script>\n";

  
  
  $output .= "<!-- \n";
  //this runs when the page has finished loading - may get over the IE onload problem
  $output .= "$(document).ready(function() {\n";
  //test how the radio buttons are set and hide or show the groups and role selectors
  //this doesn't work, I presume because the controls are hidden / not accessable during form load

  //I KNOW this is hideous - when I've time I'll make a new JQuery function to deal with this
  $output .= "$('input:radio:checked').each(function(n) {\n";
  $output .= "if (this.name == 'fwaccess') {\n";
  $output .= "if (this.value == 2) {\n";
  $output .= "$('#rwaclrole').show();\n";
  $output .= "$('#rwaclgroup').show();\n";
  $output .= "} else {\n";
  $output .= "$('#rwaclrole').hide()\n";
  $output .= "$('#rwaclgroup').hide()\n";
  $output .= "}}\n";
  $output .= "if (this.name == 'fraccess') {\n";
  $output .= "if (this.value == 2) {\n";
  $output .= "$('#roaclrole').show()\n";
  $output .= "$('#roaclgroup').show()\n";
  $output .= "} else {\n";
  $output .= "$('#roaclrole').hide()\n";
  $output .= "$('#roaclgroup').hide()\n";
  $output .= "}}});\n";
  
  if ($writeable) {
    //utterly crappy IE runs the onload code BEFORE finishing the screen. I have to put a small delay in otherwise I can't set focus
    $output .= "setTimeout(\"document.getElementById('edit-fname').focus()\",100); \n";  //add javascript to take focus
  }

  //this should make sure we can actually see the tabs
  $output .= "$('tabs-ptabs').style.display = 'block'\n";

  //code to catch the escape key being pressed
  $output .= "document.onkeypress=function(e){\n";
  $output .= "var e = window.event || e;\n";
  $output .= "if (e.keyCode == 27 || e.which == 27){\n";
  $output .= "parent.dbFM.popUp = true;\n";   //try to fill a variable to prevent a directory fetch
  $output .= "parent.GB_hide();}}\n";


  $output .= "$('form :input').change(function() {\n";
//  $output .= "alert('name is -' + this.name + '- type is -' + this.type + '- value is -' + this.value);\n";
  $output .= "if (this.name == 'fwaccess') {\n";
  //if it's the radio button that's just been pressed we need to work out whether they've selected custom
  //and hide or show the selection area's
  $output .= "if (this.value == 2) {\n";
  //hide the prompt for versions / overwrite
  $output .= "$('#rwaclrole').show()\n";
  $output .= "$('#rwaclgroup').show()\n";
  $output .= "} else {\n";
  $output .= "$('#rwaclrole').hide()\n";
  $output .= "$('#rwaclgroup').hide()\n";
  $output .= "}}\n";
  
  $output .= "if (this.name == 'fraccess') {\n";
  //if it's the radio button that's just been pressed we need to work out whether they've selected custom
  //and hide or show the selection area's
  $output .= "if (this.value == 2) {\n";
  //hide the prompt for versions / overwrite
  $output .= "$('#roaclrole').show()\n";
  $output .= "$('#roaclgroup').show()\n";
  $output .= "} else {\n";
  $output .= "$('#roaclrole').hide()\n";
  $output .= "$('#roaclgroup').hide()\n";
  $output .= "}}\n";
  $output .= "});});\n";           //end of form change function and document onload

  $output .= "// -->\n";
  $output .= "</script>\n";
 
  $output .= "</head>\n\n";
  //now put onload code entirely in JS
  $output .= "<body>\n";

  //insert the drupal form
  $output .= "<div class=\"propertiesleft\"></div>";
  $output .= "<div class=\"propertiesright\"></div>";
  $output .= "<div class=\"propertiesform\">";
  //ideally the best place to tell the greybox code whether or not it needs to refresh would be here...
  //unfortunately I couldn't make it happen so when I first call greybox I'm passing a value
  $output .= $propertiesform."</div>";
  //if the form is in read-only mode there's nothing to take the focus so I'm adding a button
  if ($writeable == false) {
    //put a close button which has the added bonus of being able to take the focus
    $output .= "<input type='button' id='focusit' value='Close' onclick='parent.GB_hide()'/>\n";
    $output .= "<script language='JavaScript'> document.getElementById('focusit').focus(); </script>\n";  //add javascript to take focus
  } 
  $output .= "</body>";
  $output .= "</html>\n";
  print $output;

}

/**
 * Submit function for the properties pop-up form. Updates the dbfm_file table.
 * @param form - not used here
 * @param form_state the address of a multidimensional array containing all the information pertaining to the form.
 * the normal parameters for a form submit
 * The problem here is that different things save different fields back to the database. A directory saves different fields from a version and there are two variations
 * for files depending on whether the file has a directory or a version as its parent.
 */
function dbfm_form_properties_submit($form, &$form_state) {
  global $base_url;
  $err = '';                //used to hold any errors
  $isadir = FALSE;          //indicates whether we're modifying a file or a directory 
  $dirname_changed = FALSE; //flag used to indicate that a  directory name has changed since the previous save, and the directory has children
  $updateerror = FALSE;     //flag to indicate there has been an error
  $namechange = FALSE;
  $nochanges = TRUE;        //flag records whether there are any changes that need to be saved

  $notes = '<br>';          //this field will be completed to show all the changes that have been made - used by notify

  $modulepath = drupal_get_path('module', 'dbfm');
  $stylepath = $base_url . '/' . $modulepath .'/css/dbfm.css';
  $jsjq = $base_url . '/' . 'misc/jquery.js';
  
  $fid = $form_state['values']['fid'];
  //drag back the existing file record
  if (($orig_rec = dbfm_selected_file_record($fid, '', $err)) == FALSE) {
    $updatemessage = "ERROR: Unable to read file record for " . $form_state['values']['fname'] . ". File may have been deleted by another user";
    //VERY unlikely
    $updateerror = TRUE;
  }  

  //Create notes field for email notifications
  ///// COMMON FIELDS  //////
  if ($form_state['values']['fdesc'] != $orig_rec->fdesc) {      
    $notes .= "Description changed from '" . $orig_rec->fdesc . "' to '" . $form_state['values']['fdesc'] . "'<br>";
    $nochanges = FALSE;
  }
  if ($form_state['values']['fkeywords'] != $orig_rec->fkeywords) {
    $notes .= "Keywords changed from '" . $orig_rec->fkeywords . "' to '" . $form_state['values']['fkeywords'] . "'<br>";
    $nochanges = FALSE;
  }
  $access[0] = 'Private - owner only';
  $access[1] = 'Public - open to all users';
  $access[2] = 'Restricted - open only to certain groups/roles';
  
  if ($form_state['values']['fraccess'] != $orig_rec->fraccess) {
    $notes .= "Read access changed from '" . $access[$orig_rec->fraccess] . "' to '" . $access[$form_state['values']['fraccess']] . "'<br>";
    $nochanges = FALSE;
  }
  if ($form_state['values']['fwaccess'] != $orig_rec->fwaccess) {
    $notes .= "Write access changed from '" . $access[$orig_rec->fwaccess] . "' to '" . $access[$form_state['values']['fwaccess']] . "'<br>";
    $nochanges = FALSE;
  }

  ///// VERSION ONLY /////
  if ($orig_rec->fmime == 'version') {
    if ($form_state['values']['fchild'] != $orig_rec->fchild) {
      $notes .= "Default version changed from '" . $orig_rec->fchild . "' to '" . $form_state['values']['fchild'] . "'<br>";
      $nochanges = FALSE;
    }
  }
  else {
    //set a flag to diferentiate between files and directories
    if ($orig_rec->fmime == 'directory') {
      //if they have permission to alter directory locking then test the lock value
      if (user_access('dbfm lock')) {
        if ($form_state['values']['locked'] != $orig_rec->flang) {
          $nochanges = FALSE;
        }
      }  
      $isadir = TRUE;
    }
    
    ///// COMMON FIELDS /////
    if ($form_state['values']['fname'] != $orig_rec->fname) {
      if ($isadir && $orig_rec->flang) {
        //don't allow a change for directories which are locked
        $form_state['values']['fname'] = $orig_rec->fname;
      }
      else {
        $notes .= "Name changed from '" . $orig_rec->fname . "' to '" . $form_state['values']['fname'] . "'<br>";
        $nochanges = FALSE;
      }  
    }
    if ($isadir == FALSE) {
      ///// FILES ONLY /////
      if ($form_state['values']['flang'] != $orig_rec->flang) {
        $languages[0] = 'English';
        $languages[1] = 'French';
        $notes .= "Language changed from '" . $languages[$orig_rec->flang] . "' to '" . $languages[$form_state['values']['flang']] . "'<br>";
        $nochanges = FALSE;
      }
      if ($form_state['values']['ftitle'] != $orig_rec->ftitle) {
        $notes .= "Title changed from '" . $orig_rec->ftitle . "' to '" . $form_state['values']['ftitle'] . "'<br>";
        $nochanges = FALSE;
      }
      //status is an integer - we need to convert to the text value
      if ($form_state['values']['fstatus'] != $orig_rec->fstatus) {
        $status[0] = 'Draft';
        $status[1] = 'Test';
        $status[2] = 'Approved';

        $notes .= "Status changed from '" . $status[$orig_rec->fstatus] . "' to '" . $status[$form_state['values']['fstatus']] . "'<br>";
        $nochanges = FALSE;
      }
      if ($form_state['values']['fclass'] != $orig_rec->fclass) {
        $class[0] = 'Unclassified';
        $class[1] = 'Contract';
        $class[2] = 'Design';
        $class[3] = 'Guidelines';
        $class[4] = 'Organisation';
        $class[5] = 'Procedure';
        $class[6] = 'Product Marketing';
        $class[7] = 'Project Management';
        $class[8] = 'Quality Management';
        $class[9] = 'Specification';
        $class[10] = 'Template';
        $class[11] = 'Testing';
        $class[12] = 'User Documentation';

        $notes .= "Class changed from '" . $class[$orig_rec->fclass] . "' to '" . $class[$form_state['values']['fclass']] . "'<br>";
        $nochanges = FALSE;
      }
      if ($form_state['values']['fnewver'] != $orig_rec->fnewver) {
        $notes .= "Version changed from '" . $orig_rec->fnewver . "' to '" . $form_state['values']['fnewver'] . "'<br>";
        $nochanges = FALSE;
      }
      if ($form_state['values']['fdistribution'] != $orig_rec->fdistribution) {
        $distribution[0] = 'Internal Only';
        $distribution[1] = 'Under Supervision';
        $distribution[2] = 'Public';

        $notes .= "Distribution changed from '" . $distribution[$orig_rec->fdistribution] . "' to '" . $distribution[$form_state['values']['fdistribution']] . "'<br>";
        $nochanges = FALSE;
      }      
    }
  }  
   
  //the while loop is a substitute for a goto - we want all errors to skip to the end!
  //the three different entry types - directories, versions and files - all save different fields and should be dealt with differently
  while (1) {
    if ($updateerror == TRUE) {
      //go straight to the bottom and report the error
      break;
    }
    
    //if this is a version and the fchild value has changed then we need to look up the file size of the new default version file and copy it to the parent at some point
    if ($orig_rec->fmime == 'version') {
      if ($orig_rec->fchild != $form_state['values']['fchild']) {
        //is fchild now set to a fid or have we got to work it out?        
        if ($form_state['values']['fchild'] > 0) {
          //select the specified version using the child fid stored in fchild
          $f = dbfm_selected_file_record($version_rec->fchild, '', $err);
        }
        else {
          //they haven't specified which version they'd like get back a list of all the versions of the file
          $qversion = "SELECT fid, fversion FROM {dbfm_file} WHERE fparent = " . $orig_rec->fid . " ORDER BY fversion DESC";
          if(($qrecs = db_query($qversion)) == FALSE) {
            watchdog("dbfm", "ERROR: Cannot access child records for version directory " . $orig_rec->fid);
            $updatemessage = "ERROR: Unable to read child version records for " . $form_state['values']['fname'] . " / " . $orig_rec->fid;
            $updateerror = TRUE;
            break;
          }
          //select the first record from the list returned - the most recent version
          $fv = db_fetch_object($qrecs);

          //open the correct file record 
          $f = dbfm_selected_file_record($fv->fid, '', $err);
        }
        //now we have the default child record lets get the file size
        $orig_rec->fsize = $f->fsize;
      }
      //what other version fields have changed -load metadata variables ready for dbfm_update. 
      $metadata=array(
        'fsize' => $orig_rec->fsize,
        'fdesc' => $form_state['values']['fdesc'],
        'fkeywords' => $form_state['values']['fkeywords'],
        'fraccess' => $form_state['values']['fraccess'],
        'fwaccess' => $form_state['values']['fwaccess'],
        'fchild' => $form_state['values']['fchild'],
      );     
	    
	} //end of code specific to versions
	else {
      //have they changed the filename/directoryname ? if so we need to vet the new name
      if ($orig_rec->fname != $form_state['values']['fname']) {
        $namechange = TRUE;
        if (!dbfm_check_name($form_state['values']['fname'], $isadir, $err)) {
          $updatemessage = "Invalid filename - " . $err;
          $updateerror = TRUE;
          break;
        }

        //has the new name already been used - search through all the children of the parent directory for a duplicate
        //we HAVE to do this - no way to sneakily get into a versions directory here!!
        $numrecs = db_result(db_query("SELECT COUNT(*) FROM {dbfm_file} WHERE fid = " . $orig_rec->fparent . " AND fname = '" . $form_state['values']['fname'] . "'"));
        if ($numrecs > 0) {
          $updatemessage = 'Rename not allowed - A file of that name already exists';
          $updateerror = TRUE; 
          break;
        }

        //they've altered the file or directory name so we may need to reform the path
        //take the path for the parent directory and append the filename
        $pathdata = $orig_rec->fpath;
        $position = (strrpos($pathdata, '/',1));  //finds the position, in the original record, of the last slash
        if ($position == 'false') {
          $updatemessage = 'Path data error. Contact your administrator.';
          $updateerror = TRUE;
          break;
        }

        $tempstring = (substr ($pathdata, 0, $position));  //returns path minus file/diectory name
        //overwrite the path
        $form_state['values']['fpath'] = $tempstring.'/'.$form_state['values']['fname'];
      }
      //we're not allowing a blank title - fill one if it's blank
      if ($form_state['values']['ftitle'] == '') {
        //was there already an entry - if so use that?
        if ($orig_rec->ftitle != '') {
          $form_state['values']['ftitle'] = $orig_rec->ftitle;
        }
        else {
          $form_state['values']['ftitle'] = $orig_rec->fname;
        }
      }
	  if ($isadir) {
        //if the directory has children we're going to need a recursive change to its children - set a flag
        if ($namechange && $orig_rec->fsize > 0) {
          $dirname_changed = TRUE;
        }
        
        //load up an array with all the fields that need to change
        $metadata=array(
          'fpath' => $form_state['values']['fpath'],
          'fname' => $form_state['values']['fname'],
          'ftitle' => $form_state['values']['ftitle'],
          'fdesc' => $form_state['values']['fdesc'],
          'flang' => $form_state['values']['locked'],
          'fraccess' => $form_state['values']['fraccess'],
          'fwaccess' => $form_state['values']['fwaccess'],
        );       
      }   //end of code for a directory
      else {
        //must be a file - there are two type of file (depending on the file's parent which we need to look up)
        $fp = dbfm_selected_file_record($orig_rec->fparent,'',$err);
        if ($fp->fmime == "version") {
          //load up an array with all the fields that need to change
          $metadata=array(
            'fpath' => $form_state['values']['fpath'],
            'fname' => $form_state['values']['fname'],
            'ftitle' => $form_state['values']['ftitle'],
            'flang' => $form_state['values']['flang'],
            'fstatus' => $form_state['values']['fstatus'],
            'fsize' => $orig_rec->fsize,
            'fclass' => $form_state['values']['fclass'],
            'fdesc' => $form_state['values']['fdesc'],
            'fkeywords' => $form_state['values']['fkeywords'],
            'fdistribution' => $form_state['values']['fdistribution'],
            'fraccess' => $form_state['values']['fraccess'],
            'fwaccess' => $form_state['values']['fwaccess'],
            'fchild' => $form_state['values']['fchild'],
            'fnewver' => $form_state['values']['fnewver'],
          );               
		}
		else {
		  //parent's just a directory
          //load up an array with all the fields that need to change
          $metadata=array(
            'fpath' => $form_state['values']['fpath'],
            'fname' => $form_state['values']['fname'],
            'ftitle' => $form_state['values']['ftitle'],
            'flang' => $form_state['values']['flang'],
            'fstatus' => $form_state['values']['fstatus'],
            'fsize' => $orig_rec->fsize,
            'fclass' => $form_state['values']['fclass'],
            'fdesc' => $form_state['values']['fdesc'],
            'fkeywords' => $form_state['values']['fkeywords'],
            'fdistribution' => $form_state['values']['fdistribution'],
            'fraccess' => $form_state['values']['fraccess'],
            'fwaccess' => $form_state['values']['fwaccess'],
            'fchild' => $form_state['values']['fchild'],
            'fnewver' => $form_state['values']['fnewver'],
          );       
		} 
      }
    }
    break;
  }  //end of while loop

  //check first whether there were any changes - the nochanges flag doesn't tell the whole story - it may be that all of the main settings remain as they were BUT
  //changes have been made to the access restrictions
  if ($nochanges) {
    $updateerror = TRUE;
    $permchange = FALSE;
    if ($form_state['values']['fraccess'] == DBFM_CUSTOM) {
      $perms_rresult = dbfm_add_perms('read', $fid,  $form_state['values']);
      if ($perms_rresult) $permchange = TRUE;
    }
    if ($form_state['values']['fwaccess'] == DBFM_CUSTOM) {
      $perms_wresult = dbfm_add_perms('write', $fid,  $form_state['values']);
      if ($perms_wresult) $permchange = TRUE;
    }
    if ($permchange) {
      $updatemessage = "Permissions were changed";
      //send a notification message
      dbfm_notify($orig_rec, 'change', "<br>Permissions were changed");
    }
    else {
      $updatemessage = "There were no changes";
    }
  }

  // if there are no errors, then update the database
  if (!$updateerror) {      
     // update the database
    if ($updateresult = dbfm_dbupdate_file($fid, $err, $metadata) == TRUE ) {        
      $updatemessage = ('The changes were saved.');
      //if either the read or write setting are 'custom then call the add perms thingy
      $permchange = false;
      //DBFM_CUSTOM is defined in the dbfm.module
      if ($form_state['values']['fraccess'] == DBFM_CUSTOM) {
        $perms_rresult = dbfm_add_perms('read', $fid,  $form_state['values']);
        if ($perms_rresult) $permchange = true;
      }
      if ($form_state['values']['fwaccess'] == DBFM_CUSTOM) {
        $perms_wresult = dbfm_add_perms('write', $fid,  $form_state['values']);
        if ($perms_wresult) $permchange = true;
      }
      if ($permchange == true) {
        $updatemessage .= (' and the permissions were altered.');
        $notes .= "Permissions were modified";
      }
      dbfm_notify($orig_rec, 'change', $notes);
    }
    else {
      $updatemessage = 'Problems updating the database record for ' . $form_state['values']['fname'];
      $updateerror = true;
    }
  } 

  //now - if the name changed and this is a directory with children we need to do a recursive change to fix the children's paths
  if ($dirname_changed) {
    $err = '';  //used to collect any error message
    //re-read the file record
    $new_rec = dbfm_selected_file_record($fid,'', $err);
    dbfm_recur_dbrename($new_rec, $ret, $err);
  }
  
  //the problem with greybox always forcing a browser refresh is that we can end up losing the current file directory - use a session 
  //variable to keep it
  $_SESSION['fid'] = $orig_rec->fparent;
  
  //now I need a means of closing the greybox - being lazy I'll just let the user do it
  $updatemessage .= t('<br><br>You should now close this window.<br><br>');
  $page_output = dbfm_popconstructor2("dbFM Window", '', $updatemessage);
  print $page_output;

  exit;
  //note that the refresh for the tree and browser are currently in the greybox code. However whether or not the refresh happens
  //is dependant on the screen element 'refreshit'
}


/** 
 * Forms/tabs for file properties
 * As with all forms - the address of the form state is passed
 */
//need to know first whether they have write access to the file - if they do then make the attributes editable
//otherwise the form is read-only
function dbfm_form_properties(&$form_state) {
  global $gfrec;  //the file record (filled in by propertit)
  global $base_url;
  $err = '';  //used to return error strings

  // These will come from the DB later - beware, this is also declared elsewhere - e.g when doing notifications!!
  $languages[0] = 'English';
  $languages[1] = 'French';

  // These will come from the DB later - beware, this is also declared elsewhere - e.g when doing notifications!! Have to get it in the database soon
  $status[0] = 'Draft';
  $status[1] = 'Test';
  $status[2] = 'Approved';

  // So will these... we promise!
  $class[0] = 'Unclassified';
  $class[1] = 'Contract';
  $class[2] = 'Design';
  $class[3] = 'Guidelines';
  $class[4] = 'Organisation';
  $class[5] = 'Procedure';
  $class[6] = 'Product Marketing';
  $class[7] = 'Project Management';
  $class[8] = 'Quality Management';
  $class[9] = 'Specification';
  $class[10] = 'Template';
  $class[11] = 'Testing';
  $class[12] = 'User Documentation';

  // And these... ugh, i feel dirty. - don't you need things like restricted??
  $distribution[0] = 'Internal Only';
  $distribution[1] = 'Under Supervision';
  $distribution[2] = 'Public';

  //get the name of the file owner
  $qowner = "SELECT name FROM {users} WHERE uid = " . $gfrec->uid;
  $queryResult = db_query($qowner);
  $ownerrec = db_fetch_object($queryResult);

  //from the node table, fill in an array - $grouplist - of all possible organic groups
  //these are id / title pairs
  if (variable_get('dbfm_node_grp', '') == '') {
    $nogroups = TRUE;
  }
  else {  
    $groupsql = "SELECT nid, title FROM {node} WHERE type = '" . variable_get('dbfm_node_grp', '') . "' ORDER BY title";
    $queryResult = db_query($groupsql);
  
    $nogroups = TRUE;
    while ($grouprecs = db_fetch_object($queryResult)) {
      $grouplist[$grouprecs->nid] = $grouprecs->title;
      $nogroups = FALSE;  //flag to indicate whether there are no groups proesent   
    }
  } 
  //if we are using groups then populate the groups lists
  if ($nogroups == FALSE) {
    //from the file's permissions, fill in an array of all those groups already chosen for the selected item - read only
    //this is just an array of ints from the dbfm_perm permissions table
    $grprolist = getpermarr($gfrec->fid, GROUP_RO);

    //from the file's permissions, fill in an array of all those groups already chosen for the selected item - read write
    //this is just an array of ints
    $grprwlist = getpermarr($gfrec->fid, GROUP_RW);
  }

  //from the role table, fill in an array - rolelist - of possible roles - should we do anything here about anonymous 
  //user and authenticated user? yes - we'll filter them out
  $rolesql = "SELECT rid, name FROM {role} WHERE rid > 2 ORDER BY name";
  $queryResult = db_query($rolesql);
  $noroles = TRUE;
  
  while ($rolerecs = db_fetch_object($queryResult)) {
    $noroles = FALSE;
    $rolelist[$rolerecs->rid] = $rolerecs->name;
  }
  if ($noroles == FALSE) {
    //from the file's permissions, fill in an array of roles already chosen for this item - read only
    //this is just an array of ints returned from the permissions table
    $rolrolist = getpermarr($gfrec->fid, ROLE_RO);

    //from the file's permissions, fill in an array of roles already chosen for this item - read write
    //this is just an array of ints
    $rolrwlist = getpermarr($gfrec->fid, ROLE_RW);
  }

  //NOW - to have got to here in the first place they needed to have read permissions for the file. We now
  //test whether they have write permissions in order to decide how to build the form
  $writeable = dbfm_check_perm($gfrec, READ_WRITE);

  //we also need to know whether these are properties for a directory, version, or file
  $objecttype = $gfrec->fmime;
  switch ($objecttype) {
    case 'directory':
      $object['ident'] = DBFM_DIRECTORY;
      $object['desc'] = 'Directory';
      break;
    case 'version':
      $object['ident'] = DBFM_VERSION;
      $object['desc'] = 'File';
      $revsql = "SELECT fid,  fversion, fstatus, fnewver FROM {dbfm_file} WHERE fparent = '".$gfrec->fid."' ORDER BY fcreatedate DESC" ;
      $queryResult = db_query($revsql);
      //fill out an array with all the curent revisions
      while ($revsql = db_fetch_object($queryResult)) {
        $revlist[$revsql->fid] = ('Rev. '.$revsql->fversion);
        if ($revsql->fnewver != NULL) {
		  $revlist[$revsql->fid] .= (' - '.$revsql->fnewver);
		}  
		//code specific to status not yet implemented - placeholder  
        switch ($revsql->fstatus) {
          case 2:
            $revlist[$revsql->fid] .= (' (Approved)');
          break;
          case 1:
            $revlist[$revsql->fid] .= (' (Test)');
          break;
          default:
            $revlist[$revsql->fid] .= (' (Draft)');
          break;
        }
      } //end of while loop
      //if the user has already specified a revision then add an extra menu choice allowing then to revert to the latest
//      if ($gfrec->fchild != 0) {
        $revlist[0] = ('Latest');
//	  }

    break;
    default:
      $object['ident'] = DBFM_OTHER;
      $object['desc'] = 'File';
    break;
  }

  //we need to keep the submit button somehow seperate from the tabs - and we don't have a submit button if the form's read 
  //only. NOTE: That the class divs span a number of controls
  $form = array();

  $content = $object['desc'].' '.t('properties: '.$gfrec->fid);

  $form['properties'] = array(
    '#type' => 'tabset',
  );

  $form['properties']['general'] = array(
    '#type' => 'tabpage',
    '#title' => t('General'),
  );

  $form['properties']['general']['fakefid'] = array(
    '#type'=> 'hidden',
    '#title' => $content,
    '#size' => '10',
    '#maxlength' => '10',
    '#value' => $gfrec->fid,
    '#prefix' => '<div class="formtop">',
  );

  $form['properties']['general']['fakepath'] = array(
    '#type'=> 'item',
    '#title' => t('Path'),
    '#value' => $gfrec->fpath,
    '#suffix' => '</div>',
 );

  $form['properties']['general']['fid'] = array(
    '#type'=> 'hidden',
    '#title' => $content,
    '#value' => $gfrec->fid,
  );

  $form['properties']['general']['fpath'] = array(
    '#type'=> 'hidden',
    '#title' => t('Path'),
    '#value' => $gfrec->fpath,
  );
  
  //now we need to know whether we've got a file or a directory and display contents accordingly

  //main form left class div starts here
  $content = $object['desc'].' '.t('name');

  if ($object['ident'] == DBFM_DIRECTORY) {
    //you cannot edit the name of a locked directory
    if ($writeable && ($gfrec->flang == FALSE)) {
      $form['properties']['general']['fname'] = array(
        '#type'=> 'textfield',
        '#title' => $content,
        '#size' => '30',
        '#maxlength' => '255',
        '#default_value' => $gfrec->fname,
        '#prefix' => '<div class="formleft">',
        '#suffix' => '</div>',
      );
    }
    else {
      $form['properties']['general']['fname'] = array(
        '#type'=> 'item',
        '#title' => $content,
        '#value' => $gfrec->fname,
        '#prefix' => '<div class="formleft">',
        '#suffix' => '</div>',
      );
    }
    //if we're god then we can make this directory 'locked' that is to say make it impossible for most users to move the directory. 
    if (user_access('dbfm lock')) {
      $form['properties']['general']['locked'] = array(
        '#type'=> 'checkbox',
        '#title' => t('Lock Directory'),
        '#default_value' => $gfrec->flang,
      );
    }
	else {
	  //mere mortals only get text telling them whether the directory's locked or not
	  if ($gfrec->flang) {
	    $lockval = "locked";
	  }
	  else {
	     $lockval = "unlocked";
	  }  
      $form['properties']['general']['ltext'] = array(
        '#type'=> 'item',
        '#value' => "Directory is " . $lockval,
      );
	}          

  }
  else if ($object['ident'] == DBFM_VERSION) {
    $form['properties']['general']['fakefname'] = array(
      '#type'=> 'item',
      '#title' => $content,
      '#value' => $gfrec->fname,
      '#prefix' => '<div class="formleft">',
      '#suffix' => '</div>',
    );
    $form['properties']['general']['fname'] = array(
      '#type'=> 'hidden',
      '#title' => $content,
      '#value' => $gfrec->fname,
    );
  }
  else {
    if ($writeable) {
      //checking for a version id greater then 0 tells us that this is the child of a revision master
      if ($gfrec->fversion > 0) {
        $form['properties']['general']['fnewver'] = array(
          '#type'=> 'textfield',
          '#size' => '30',
          '#title' => t('File Version'),
          '#default_value' => $gfrec->fnewver,
          '#prefix' => '<div class="formleft">'
        );
        $form['properties']['general']['fname'] = array(
          '#type'=> 'textfield',
          '#title' => $content,
          '#size' => '30',
          '#maxlength' => '255',
          '#default_value' => $gfrec->fname
        );
      }
      else {
        $form['properties']['general']['fname'] = array(
          '#type'=> 'textfield',
          '#title' => $content,
          '#size' => '30',
          '#maxlength' => '255',
          '#default_value' => $gfrec->fname,
          '#prefix' => '<div class="formleft">'
        );
      }
    }
    else {
      $form['properties']['general']['fname'] = array(
        '#type'=> 'item',
        '#title' => $content,
        '#value' => $gfrec->fname,
        '#prefix' => '<div class="formleft">',
      );
    }

    if ($writeable) {
      $form['properties']['general']['ftitle'] = array(
        '#type'=> 'textfield',
        '#title' => t('File Title'),
        '#size' => '30',
        '#maxlength' => '255',
        '#default_value' => $gfrec->ftitle,
      );
    }
    else {
      $form['properties']['general']['ftitle'] = array(
        '#type'=> 'item',
        '#title' => t('File Title'),
        '#value' => $gfrec->ftitle,
      );
    }

    if ($writeable) {   
      $form['properties']['general']['flang'] = array(
        '#type' => 'select', 
        '#title' => t('Language'), 
        '#default_value' => $gfrec->flang,
        '#options' => $languages,
      );
    }
    else {
      //we have to find the text value associated with the integer held in flang
      $lval = $languages[$gfrec->flang];
      $form['properties']['general']['flang'] = array(
        '#type' => 'item',
        '#title' => t('Language'),
        '#value' => $lval,
      );
    }

    if ($writeable) {
      $form['properties']['general']['fstatus'] = array(
        '#type' => 'select', 
        '#title' => t('Status'), 
        '#default_value' => $gfrec->fstatus,
        '#options' => $status,
      );
    }
    else {
      $sval = $status[$gfrec->fstatus];
      $form['properties']['general']['fstatus'] = array(
        '#type' => 'item',
        '#title' => t('Status'),
        '#value' => $sval,
      );
    }

    if ($writeable) {
      $form['properties']['general']['fdistribution'] = array(
        '#type' => 'select',
        '#title' => t('Distribution'),
        '#default_value' => $gfrec->fdistribution,
        '#options' => $distribution
      );
    }
    else {
      $dval = $distribution[$gfrec->fdistribution];
      $form['properties']['general']['fdistribution'] = array(
        '#type' => 'item',
        '#title' => t('Distribution'),
        '#value' => $dval,
      );
    }

    if ($writeable) {
      $form['properties']['general']['fclass'] = array(
        '#type' => 'select', 
        '#title' => t('Class'),
        '#default_value' => $gfrec->fclass,
        '#options' => $class,
        '#suffix' => '</div>',
      );
    }
    else {
      $pval = $class[$gfrec->fclass];
      $form['properties']['general']['fclass'] = array(
        '#type' => 'item',
        '#title' => t('Class'),
        '#value' => $pval,
        '#suffix' => '</div>',
      );
    }
  }

  switch ($object['ident']) {
    case DBFM_DIRECTORY:
      $content = t('Files/Directories');
    break;
    case DBFM_VERSION:
      $content = t('Files');
    break;
    default:
      $content = t('Size');
    break;
  }

  //start of form left class div - these fields are already read-only
  $form['properties']['general']['fsize'] = array(
    '#type'=> 'item',
    '#title' => $content,
    '#value' => $gfrec->fsize,
    '#prefix' => ('<div class="formright">')
  );

  $form['properties']['general']['flastmod'] = array(
    '#type'=> 'item',
    '#title' => t('Modified'),
    '#value' => $gfrec->flastmod
  );

  $form['properties']['general']['fcreatedate'] = array(
    '#type'=> 'item',
    '#title' => t('Created'),
    '#value' => $gfrec->fcreatedate
  );

  $form['properties']['general']['ownerinfo'] = array(
    '#type'=> 'item',
    '#title' => t('Owner'),
    '#value' => $ownerrec->name,
  );

  $form['properties']['general']['fmime'] = array(
    '#type'=> 'item',
    '#title' => t('Type'),
    '#value' => $gfrec->fmime
  );

  if (stristr($gfrec->fmime, 'image')){
    $form['properties']['general']['fimagesize'] = array(
      '#type'=> 'item',
      '#title' => t('Dimensions'),
      '#value' => $gfrec->fimagesize,
      '#suffix' => ('<img src="'.$base_url.'/dbfm_send/'.$gfrec->fid .'">')
    );
  }
  //number of downloads - this needs to be modified such that it better relects the true number of accesses ZZZZZZZZZZZ
  if ($object['ident'] > DBFM_VERSION) {
    $form['properties']['general']['fdown'] = array(
      '#type'=> 'item',
      '#title' => t('Views'),
      '#value' => $gfrec->fdown,
    );
  }

  //^^ end of the form right div
  if ($object['ident'] > DBFM_DIRECTORY) {
    $form['properties']['general']['fdesc'] = array(
      '#type'=> 'textarea',
      '#title' => t('Notes'),
      '#size' => '30',
      '#rows' => '2',
      '#default_value' => $gfrec->fdesc,
      '#disabled' => !$writeable,
      '#prefix' => '</div><div class="formbottom">',
    );
  //
  if ($object['ident'] == DBFM_VERSION) {
    if ($writeable) {
      $form['properties']['general']['fchild'] = array(
        '#type' => 'select', 
        '#title' => t('Current Revision'), 
        '#default_value' => $gfrec->fchild,
        '#options' => $revlist,
      );
    }
    else {
      $fchildver = ('Rev. '.$gfrec->fversion);
      if ($gfrec->fnewver != NULL) $fdownver .= (' - '.$gfrec->fnewver);
        switch ($gfrec->fstatus) {
          case 2:
            $fchildver .= (' (Approved)');
            break;
          case 1:
            $fchildver .= (' (Test)');
            break;
          default:
            $fchildver .= (' (Draft)');
            break;
        }

        $form['properties']['general']['fchild'] = array(
          '#type' => 'item',
          '#title' => t('Current Revision'),
          '#value' => $fchildver,
        );
      }
    }
//
    $form['properties']['general']['fkeywords'] = array(
      '#type'=> 'textarea',
      '#title' => t('Keywords'),
      '#size' => '30',
      '#rows' => '1',
      '#default_value' => $gfrec->fkeywords,
      '#disabled' => !$writeable,
      '#suffix' => '</div>'
    );
  }
  else {
    $form['properties']['general']['fdesc'] = array(
      '#type'=> 'textarea',
      '#title' => t('Notes'),
      '#size' => '30',
      '#rows' => '3',
      '#default_value' => $gfrec->fdesc,
      '#disabled' => !$writeable,
      '#prefix' => '</div><div class="formbottom">',
      '#suffix' => '</div>'
    );
  }

  // ZZZ content for the access form, need to differentiate between files and directories
  $content = $object['desc'].' '.t('Permissions');

  $form['properties']['accessrw'] = array(
    '#type' => 'tabpage',
    '#title' => t('Read/Write Access'),
  );

  //radio set to allow them to chose between private, public and custom Need some mechanism (in java?) to grey out the role/group
  //boxes unless custom is selected. By default files will inherit permissions from their parent directory ZZZ we need the code (when we create a new file) 
  //to fill in these details into the access table
  $form['properties']['accessrw']['fwaccess'] = array(
    '#type' => 'radios',
    '#title' => t('Access Type'),
    '#default_value' => $gfrec->fwaccess,
    '#disabled' => !$writeable,
    '#prefix' => '<div id="radiorw">',
    '#suffix' => '</div>',

    '#options' => array(DBFM_PRIVATE => t('Private, only writeable by the owner (or an administrator)'),
      DBFM_PUBLIC => t('Public, writable by all users.'),
      DBFM_CUSTOM => t('Restricted, writeable by the file owner (and the roles and groups detailed below - optional)')),
  );
  
  if ($noroles == FALSE) {
    $form['properties']['accessrw']['roletxt'] = array(
      '#type'=> 'item',
      '#title' => t('Roles'),
      '#prefix' => ('<div class="aclrole" id="rwaclrole"><div class="txtlbl">'),
      '#suffix' => ('</div>')
    );

    $form['properties']['accessrw']['wrole'] = array(
     '#type' => 'select',
     '#options' => $rolelist,
     '#multiple' => true,
     '#disabled' => !$writeable,
     '#default_value' => $rolrwlist,
     '#size' => 7,       //number of lines in the select box
     '#description' => t('Select the roles whose users should have read/write access to this file/directory'),
     '#suffix' => ('</div>')
    );
  }
  if ($nogroups == FALSE) {
    $form['properties']['accessrw']['grouptxt'] = array(
      '#type'=> 'item',
      '#title' => t('Workgroups'),
      '#prefix' => ('<div class="aclgroup" id="rwaclgroup"><div class="txtlbl">'),
      '#suffix' => ('</div>')
    );

    $form['properties']['accessrw']['wgroup'] = array(
     '#type' => 'select',
     '#options' => $grouplist,
     '#multiple' => true,
     '#disabled' => !$writeable,
     '#default_value' => $grprwlist,
     '#size' => 7,    //number of lines in the select box
     '#description' => t('Select the groups whose users should have read/write access to this file/directory'),
     '#suffix' => ('</div>')
    );
  }
  if ($nogroups == FALSE AND $noroles == FALSE) {
    $form['properties']['accessrw']['instruct'] = array(
      '#type'=> 'item',
      '#value' => t('Note that it is NOT necessary to add roles and groups to the read access lists if they appear on the read/write lists'),
    );
  }

  // content for the access form, need to differentiate between files and directories
  $content = $object['desc'].' '.t('Permissions');

  $form['properties']['accessro'] = array(
    '#type' => 'tabpage',
    '#title' => t('Read Access'),
  );

  //radio set to allow them to chose between private, public and custom Need some mechanism (in java?) to grey out the role/group
  //boxes unless custom is selected. By default files will inherit permissions from their parent directory ZZZ we need the code (when we create a new file) 
  //to fill these details into the access table
  $form['properties']['accessro']['fraccess'] = array(
    '#type' => 'radios',
    '#title' => t('Access Type'),
    '#default_value' => $gfrec->fraccess,
    '#disabled' => !$writeable,
    '#prefix' => '<div id="radioro">',
    '#suffix' => '</div>',

    '#options' => array(DBFM_PRIVATE => t('Private, only accessible by the owner (or an administrator)'), 
      DBFM_PUBLIC => t('Public, accessable by all users.'), 
      DBFM_CUSTOM => t('Restricted, accessable by the file owner (and the roles and groups detailed below - optional)')), 
  );

  if ($noroles == FALSE) { 
    $form['properties']['accessro']['roletxt'] = array(
      '#type'=> 'item',
      '#title' => t('Roles'),
      '#prefix' => ('<div class="aclrole" id="roaclrole"><div class="txtlbl">'),
      '#suffix' => ('</div>')
    );

    $form['properties']['accessro']['rrole'] = array(
     '#type' => 'select',
     '#default_value' => $rolrolist,
     '#options' => $rolelist,
     '#disabled' => !$writeable,
     '#multiple' => true,
     '#size' => 7,
     '#description' => t('Select the roles whose users should have read access to this file/directory'),
     '#suffix' => ('</div>')
    );
  }
  if ($nogroups == FALSE) {
    $form['properties']['accessro']['grouptxt'] = array(
      '#type'=> 'item',
      '#title' => t('Workgroups'),
      '#prefix' => ('<div class="aclgroup" id="roaclgroup"><div class="txtlbl">'),
      '#suffix' => ('</div>')
    );

    $form['properties']['accessro']['rgroup'] = array(
     '#type' => 'select',
     '#default_value' => $grprolist,
     '#options' => $grouplist,
     '#disabled' => !$writeable,
     '#multiple' => true,
     '#size' => 7,
     '#description' => t('Select the groups whose users should have read access to this file/Directory'),
     '#suffix' => ('</div>')
    );
  }

  $form['properties']['accessro']['endpart'] = array(
    '#type' => 'item'
  );

  if ($writeable) {
    // the floating submit button for all tabs
    $form['properties']['submit'] = array(
      '#type' => 'submit',
      '#value' => t('Save changes'),
      '#prefix' => '<div class="formcontrols">',
      '#suffix' => '</div>'
    );
  }

  return $form;
  
//note that the submit code must make sure the path is changed if the filename is changed
//directories will NOT allow a change of name here. It would involve recursive code changing the paths
//of every child. The code already exists as a context menu option and I can't see the need to link to it here.  
}
