<?php
/**
 * Displays the file susbcription table on 'My account' forms. Passed an array of arrays containing all the file details
 * @param header - table header
 * @param files - an array of file details, used to create the file rows
 */
function theme_dbfm_subscriptions($header, $files) {
  global $base_url;
 
  //the file rows
  $rows = array();
  $countme = 0;
  foreach ($files as $file) {
    $countme = $countme + 1;
    $icon_path = $base_url.'/'.variable_get('dbfm_icon_dir', '').'/mime/'. $file[icon];
    $description = '';

    //note that dbfm_send may be passed the additional parameter 1 meaning that we always send the file rather than trying to display it on screen
    $href = array('data' => l('<img src="'.$icon_path.'" alt="[file]" title="Download '. $file[path] . '"/> ', 'dbfm_send/'. $file[id] . '/1', array('attributes' => array('title' => 'Download '. $file[path]), 'query' => '' , 'fragment' => '' , 'absolute' => TRUE, 'html' => TRUE)) . l($file[n], 'dbfm_send/' . $file[id], array('attributes' => array('title' => 'Open ' . $file[path]))) . $description, 'class' => 'sub-path');

    //note that dbfm_send may be passed the additional parameter 1 meaning that we always send the file rather than trying to display it on screen
    //strip the filename from the full path then use that as a link - does it work for revisions?? Nah - we need to send rthe parent id
	$dirpath = 'dbfm/' . $file[pid];    //append the parent ID   
    $href2 = array('data' => l(Inspect, $dirpath, array('attributes' => array('title' => 'Inspect folder for ' . $file[path]))));


    //add the subscribe / unsubscribe button - but only if subscriptions have been enabled
    if (variable_get("dbfm_subson", false)) {
      if ($file[sub]) {
        //if they're already subscribed
        $btn = array('data' => but('Unsubscribe',"on","but_" . $file[id], "togglestyle(this)")); 
      }
      else {
        //they're not subscribed yet
        $btn = array('data' => but('Subscribe',"off","but_" . $file[id], "togglestyle(this)")); 
      }
    }
    
//	array('title' => 'Download '. $file[path]), '' , '' , '', TRUE) . l($file[path], 'dbfm_send/' . $file[id], array('attributes' => array('title' => 'Open ' . $file[path]))) . $description, 'class' => 'sub-path');

    $row = array();
    array_push($row, $href);
    array_push($row, $href2);
    array_push($row, array('data' => $file[c], 'class' => 'sub-time'));    
    array_push($row, array('data' => $file[m], 'class' => 'sub-time'));
    array_push($row, array('data' => format_size($file[s]), 'class' => 'sub-size'));
    if (variable_get("dbfm_subson", false)) {
      array_push($row, $btn);
    }
    array_push($rows, $row);
  }
  if (count($rows))
    return theme('table', $header, $rows, array('id' => 'dbfm-sub-list'));
  else {
    //give a message saying there are no susbscribed docs
    return "There are no subscribed documents";
  }  
 }
 
 /**
  * this function merely generates a button, the function needs the following parameters
  * @param btext - the text to appear on the button
  * @param bclass - the class for the button
  * @param bid  - the id for the button
  * @param onc - the javascript function to run when the button is pressed
  * @param bback - the background image to appear on the button
  */
 function but($btext, $bclass, $bid, $onc = NULL) {
  return '<input type="button" id="' . $bid . '" value="' . $btext . '" class="' . $bclass . '" onclick="' . $onc . '" />';
 }
 
 
 /**
 * Displays file attachments in a table on node view form
 * @param files - an array of files to attach
 * @return - returns the themed list of file attachments
 */
function theme_dbfm_attachments($files) {
  global $base_url;
  $header = array(t('Attachment'));
  
  array_push($header, t('Date'));
  array_push($header, t('Size'));

  $rows = array();
  foreach ($files as $file) {
    $icon_path = $base_url.'/'.variable_get('dbfm_icon_dir', '').'/mime/'. $file[icon];
    $description = '';
    //do we use title or filename - in our case it should surely be title which will default to filename if not filled in
  	$filename = $file[n];

    //note that dbfm_send is passed the additional parameter 1
    $href = array('data' => l('<img src="'.$icon_path.'" alt="[file]" title="Download '.$filename .'"/> ', 'dbfm_send/'.$file[id].'/1', array('attributes' => array('title' => 'Download '.$filename), 'query' => '' , 'fragment' => '' , 'absolute' => TRUE, 'html' => TRUE)).l($filename, 'dbfm_send/'.$file[id], array('attributes' => array('title' => 'Open '.$filename))).$description, 'class' => 'att-title');

    $row = array();
    array_push($row, $href);
    array_push($row, array('data' => $file[m], 'class' => 'att-time'));
    array_push($row, array('data' => format_size($file[s]), 'class' => 'att-size'));
    array_push($rows, $row);
  }
//    if (count($rows))
    return theme('table', $header, $rows, array('id' => 'dbfm-attach-list'));
}

/**
 * the attachlist for the drupal node form 
 * @param node - not used here
 * @return form
 */
function dbfm_attach_attached_form($node) {
  $form['#theme'] = 'dbfm_attach_attached_form';

  // This form input will hold the ordered list of attached fids
  $form['new']['attachlist']  = array(
    '#type' => 'hidden',
    '#value' => '');
  return $form;
}

/**
 * Theme the attachment form/list.
 * @param form to render
 * @return returns the rendered form
 */
function theme_dbfm_attach_attached_form($form) {
  $output = drupal_render($form);
  return $output;
}

/**
 * @param form - passed the form to be themed
 * @return - returns a themed version of the form
 */ 
function theme_dbfm_settings_sizes_form(&$form) {
  $header = array(t('Label'), t('Width'), t('Height'));
  foreach (element_children($form) as $key) {
    $row = array();
    $row[] = drupal_render($form[$key]['label']);
    $row[] = drupal_render($form[$key]['width']);
    $row[] = drupal_render($form[$key]['height']);
    $rows[] = $row;
  }
  $output = theme('table', $header, $rows);
  $output .= drupal_render($form);
  return $output;
}
